(function (){
    "use strict";
    
    var htmlRoot;
    var mediaRoot;
    
    var videoDiv;
    var yahooIntroVideo;
    var yahooUserVideo;
    var clickForAudio;
    var videoPoster;
    var loadingCover;
    var userVideoIsSetup = false;
    
    var playIconHoverState;
    var clickForAudioHoverState;
    
    var hotspot_introVideo;
    var hotspot_general;
    var hotspot_cta;
    var hotspot_product;
    
    
    function mouseEnterPoster(evt) {
        playIconHoverState.style.display = 'block';
     }
    
    function mouseLeavePoster(evt) {
        playIconHoverState.style.display = 'none';
    }
    
    function mouseEnterIntroHotspot(evt) {
        clickForAudioHoverState.style.display = 'block';
     }
    
    function mouseLeaveIntroHotspot(evt) {
        clickForAudioHoverState.style.display = 'none';
    }
    
    function clickedCTAHotspot(evt) {
        //console.log('clickedCTAHotspot');
        if(userVideoIsSetup) {
            yahooUserVideo.pause();
        }
        evt.stopPropagation();
    }
    
    function userVideoComplete(evt) {
        videoDiv.style.display = 'none';
        loadingCover.style.display = 'none';
        videoPoster.style.display = 'block';
    }
    
    function setupUserVideo() {
        var videoHTML =
            "<video id='userVideo' controls>" +
                "<source src='" + mediaRoot + "videos/user.mp4' type='video/mp4'></source>" +
                "<source src='" + mediaRoot + "videos/user.webm' type='video/webm'></source>" +
            "</video>";
        videoDiv.innerHTML = videoHTML;
        videoDiv.style.display = "block";

        yahooUserVideo = document.getElementById("userVideo");
        
        yahooUserVideo.addEventListener('ended', userVideoComplete, false);

        hotspot_introVideo.style.display = "none";
        
        yahooUserVideo.volume = 1.0;
        yahooUserVideo.load();
        yahooUserVideo.play();
        
        videoPoster.style.display = 'none';
        
        userVideoIsSetup = true;
    }
    
    function clickedIntroVideoHotspot(evt) {
        //console.log('clickedIntroVideoHotspot');
        videoPoster.style.display = 'none'; 
        setupUserVideo();
        evt.stopPropagation();
    }
    
    function clickedUserVideoHotspot(evt) {
        //console.log('clickedUserVideoHotspot');
        evt.stopPropagation();
    }
    
    function clickedGeneralHotspot(evt) {
        //console.log('clickedGeneralHotspot');
        if(userVideoIsSetup) {
            yahooUserVideo.pause();
        }
        evt.stopPropagation();
    }
    
    function clickedProductHotspot(evt) {
        //console.log('clickedLogoHotspot');
        if(userVideoIsSetup) {
            yahooUserVideo.pause();
        }
        evt.stopPropagation();
    }
    
    function clickedVideoPoster(evt) {
        if(userVideoIsSetup) {
            //console.log('clickedVideoPoster');
            videoDiv.style.display = 'block';
            videoPoster.style.display = 'none';
            
            yahooUserVideo.volume = 1.0;
            yahooUserVideo.currentTime = 0;
            yahooUserVideo.play();
            evt.stopPropagation();
        } else {
            setupUserVideo();  
        }
        evt.stopPropagation();
    }
    
    function setupListeners() {
        hotspot_introVideo.addEventListener('click', clickedIntroVideoHotspot);
        hotspot_introVideo.addEventListener('mouseenter', mouseEnterIntroHotspot);
        hotspot_introVideo.addEventListener('mouseleave', mouseLeaveIntroHotspot);
        hotspot_general.addEventListener('click', clickedGeneralHotspot);
        hotspot_cta.addEventListener('click', clickedCTAHotspot);
        hotspot_product.addEventListener('click', clickedProductHotspot);
        videoPoster.addEventListener('click', clickedVideoPoster);
        videoPoster.addEventListener('mouseenter', mouseEnterPoster);
        videoPoster.addEventListener('mouseleave', mouseLeavePoster);
    }
    
    function setupVariables() {
        videoDiv = document.getElementById('videoPlayerACT');
        videoPoster = document.getElementById('video_poster');
        clickForAudio = document.getElementById('click_for_audio');
        clickForAudioHoverState = document.getElementById('click_for_audio_hover');
        loadingCover = document.getElementById('loadingCover');
        hotspot_introVideo = document.getElementById('hotspot_videoIntro');
        hotspot_general = document.getElementById('hotspot_general');
        hotspot_cta = document.getElementById('hotspot_cta');
        hotspot_product = document.getElementById('hotspot_product');
        playIconHoverState = document.getElementById('play_icon_hover');
    }
    
    function introVideoComplete(evt) {
        yahooIntroVideo.removeEventListener("ended", introVideoComplete);
        
        hotspot_introVideo.removeEventListener('mouseenter', mouseEnterIntroHotspot);
        hotspot_introVideo.removeEventListener('mouseleave', mouseLeaveIntroHotspot);
        hotspot_introVideo.style.display = 'none';
        videoPoster.style.display = 'block';
        loadingCover.style.display = 'none';
        
        videoDiv.removeChild(yahooIntroVideo);
    }
    
    function setupIntroVideo() {
        var videoHTML =
            "<video id='introVideo'>" +
                "<source src='" + mediaRoot + "videos/intro.mp4' type='video/mp4'></source>" +
                "<source src='" + mediaRoot + "videos/intro.webm' type='video/webm'></source>" +
            "</video>";
        videoDiv.innerHTML = videoHTML;

        yahooIntroVideo = document.getElementById("introVideo");

        yahooIntroVideo.addEventListener("ended", introVideoComplete, false);

        yahooIntroVideo.volume = 0.0;
        yahooIntroVideo.addEventListener("loadeddata", function(evt){
            yahooIntroVideo.play();
        });
        yahooIntroVideo.load();
    }
    
    function windowIsLoaded(evt) {
        mediaRoot = 'https://v4s.yimg.com/cv/ae/cascade/160326/e/';
        setupVariables();
        setupListeners();
        setupIntroVideo();
    }
    
     window.addEventListener('load', windowIsLoaded);
})();